
' === EZ1HotSauce.bas ====================== Ron Hackett ===

' This program runs on the SERVO TankBot. It uses an EZ1
' untrasonic module to search for & find a hot sauce bottle. 
	

' === Constants ====

	symbol motR =   4		' Right Motor on output 4
	symbol motL =   5		' Left  Motor on output 5
	
								' The following are "fast" speeds
	symbol  fdL = 183		' for my  left servo, 133+50=183
	symbol  bkL =  83		' for my  left servo, 133-50= 83
	symbol  fdR =  83		' for my right servo, 133-50= 83
	symbol  bkR = 183		' for my right servo, 133+50=183

								' The following are "slow" speeds
	symbol fdsL = 143		' for my  left servo, 133+10=148
	symbol bksL = 123		' for my  left servo, 133-10=118
	symbol fdsR = 123		' for my right servo, 133-10=118	
	symbol bksR = 143		' for my right servo, 133+10=148
				
	symbol  EZ1 =   1		' EZ1 on AnalogIn1	
	symbol  LED =   2		' debugging LED on output2


' === Variables ====

	symbol dist = w0		' data from EZ1	
	
	
' === Directives ===

	#com3						' specify serial port
	#picaxe 14M				' specify processor
	
	
' === Begin Main Program ===================================

	dirsc = %00000110		' see text
	
	servo motL, fdsL		' begin rotating to the right
	servo motR, bksR
	pause 250	  

do
	gosub sonar
loop until dist < 30		' turn until hot sauce is in sight
	
	low motL					' stop before changing direction
	low motR					' to reduce strain on servos
	pause 250
	
	servo motL, fdL		' go forward
	servo motR, fdR	  

do
	gosub sonar
loop until dist < 8		' get as close as possible

	pause 1500				' get even closer!	
	low motL					' stop, and enjoy the sauce!
	low motR

end


' === End Main Program - Subroutines Follow ================


' === Sonar Subroutine =====================================

sonar:

	high LED					' used for debugging
	pause 100
  	readadc10 EZ1,dist	' get EZ1 raw data
  	dist = dist / 2		' convert to inches (see text)
  	low LED
  	pause 400
  	
  	Return

